// *****************************************************************************
//
// Copyright. 2007. Symvionics, Inc. All rights reserved.
// 
// Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
// and redistribute this software, in both source code and binary forms, and the
// accompanying documentation, if any, free of charge, provided that this
// paragraph, and the following two paragraphs appear in all copies and in all
// derivative works.  In no event shall this source code or this license thereto
// impact upon or fall within the scope of any otheragreement that you have with
// Symvionics.
// 
// BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
// BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
// CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
// SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
// YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
// ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
// BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
// USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
// 
// SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
// HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR 
// MAINTENANCE.
//
// *****************************************************************************
// SampleDialogDisplay.h : Declaration of the CSampleDialogDisplay
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "SampleAxControlVS2005.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif


// CSampleDialogDisplay
class ATL_NO_VTABLE CSampleDialogDisplay :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISampleDialogDisplay, &IID_ISampleDialogDisplay, &LIBID_SampleAxControlVS2005Lib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<CSampleDialogDisplay>,
	public IOleControlImpl<CSampleDialogDisplay>,
	public IOleObjectImpl<CSampleDialogDisplay>,
	public IOleInPlaceActiveObjectImpl<CSampleDialogDisplay>,
	public IViewObjectExImpl<CSampleDialogDisplay>,
	public IOleInPlaceObjectWindowlessImpl<CSampleDialogDisplay>,
	public ISupportErrorInfo,
	public IPersistStorageImpl<CSampleDialogDisplay>,
	public ISpecifyPropertyPagesImpl<CSampleDialogDisplay>,
	public IQuickActivateImpl<CSampleDialogDisplay>,
#ifndef _WIN32_WCE
	public IDataObjectImpl<CSampleDialogDisplay>,
#endif
	public IProvideClassInfo2Impl<&CLSID_SampleDialogDisplay, NULL, &LIBID_SampleAxControlVS2005Lib>,
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	public IObjectSafetyImpl<CSampleDialogDisplay, INTERFACESAFE_FOR_UNTRUSTED_CALLER>,
#endif
	public CComCoClass<CSampleDialogDisplay, &CLSID_SampleDialogDisplay>,
	public CComCompositeControl<CSampleDialogDisplay>,
  public IPersistPropertyBagImpl<CSampleDialogDisplay> // Add this so Iads can save your display
{
public:

  double mValue1;
  double mValue2;
  double mValue3;

	CSampleDialogDisplay()
	{
		m_bWindowOnly = TRUE;
    mValue1 = 0.0;
    mValue2 = 0.0;
    mValue3 = 0.0;
		CalcExtent(m_sizeExtent);
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_INSIDEOUT |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_SAMPLEDIALOGDISPLAY)


BEGIN_COM_MAP(CSampleDialogDisplay)
	COM_INTERFACE_ENTRY(ISampleDialogDisplay)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
#ifndef _WIN32_WCE
	COM_INTERFACE_ENTRY(IDataObject)
#endif
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	COM_INTERFACE_ENTRY_IID(IID_IObjectSafety, IObjectSafety)
#endif

  COM_INTERFACE_ENTRY(IPersistPropertyBag)  // Add this so Iads can save your display

END_COM_MAP()

BEGIN_PROP_MAP(CSampleDialogDisplay)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)

  // Now, list each property here to be saved by Iads
  PROP_ENTRY( "Value1",     1,  CLSID_NULL)  // Entry required for saving property (name,id)
  PROP_ENTRY( "Value2",     2,  CLSID_NULL)  // Entry required for saving property (name,id)
  PROP_ENTRY( "Value3",     3,  CLSID_NULL)  // Entry required for saving property (name,id)

END_PROP_MAP()


BEGIN_MSG_MAP(CSampleDialogDisplay)
	CHAIN_MSG_MAP(CComCompositeControl<CSampleDialogDisplay>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

BEGIN_SINK_MAP(CSampleDialogDisplay)
	//Make sure the Event Handlers have __stdcall calling convention
END_SINK_MAP()

	STDMETHOD(OnAmbientPropertyChange)(DISPID dispid)
	{
		if (dispid == DISPID_AMBIENT_BACKCOLOR)
		{
			SetBackgroundColorFromAmbient();
			FireViewChange();
		}
		return IOleControlImpl<CSampleDialogDisplay>::OnAmbientPropertyChange(dispid);
	}
// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] =
		{
			&IID_ISampleDialogDisplay,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// ISampleDialogDisplay

	enum { IDD = IDD_SAMPLEDIALOGDISPLAY };

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}
  STDMETHOD(get_Value1)(DOUBLE* pVal);
  STDMETHOD(put_Value1)(DOUBLE newVal);
  STDMETHOD(get_Value2)(DOUBLE* pVal);
  STDMETHOD(put_Value2)(DOUBLE newVal);
  STDMETHOD(get_Value3)(DOUBLE* pVal);
  STDMETHOD(put_Value3)(DOUBLE newVal);
};

OBJECT_ENTRY_AUTO(__uuidof(SampleDialogDisplay), CSampleDialogDisplay)
