// *****************************************************************************
//
// Copyright. 2007. Symvionics, Inc. All rights reserved.
// 
// Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
// and redistribute this software, in both source code and binary forms, and the
// accompanying documentation, if any, free of charge, provided that this
// paragraph, and the following two paragraphs appear in all copies and in all
// derivative works.  In no event shall this source code or this license thereto
// impact upon or fall within the scope of any otheragreement that you have with
// Symvionics.
// 
// BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
// BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
// CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
// SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
// YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
// ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
// BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
// USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
// 
// SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
// HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR 
// MAINTENANCE.
//
// *****************************************************************************
// SampleEveryDataPoint.h : Declaration of the CSampleEveryDataPoint
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "SampleAxControlVS2005.h"

// Add Iads.idl and IadsTime.idl to the project (as the tutorial shows). After that is complete, Add these to the include files
#include "Iads.h"           
#include "IadsTime.h"       

// Add these files to the stdafx.cpp file
//#include "Iads.h"         
//#include "Iads_i.c"
//#include "IadsTime.h"
//#include "IadsTime_i.c"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// Example to process every data point from within a display. Follow the steps 1..N in the code below

// CSampleEveryDataPoint
class ATL_NO_VTABLE CSampleEveryDataPoint :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISampleEveryDataPoint, &IID_ISampleEveryDataPoint, &LIBID_SampleAxControlVS2005Lib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<CSampleEveryDataPoint>,
	public IOleControlImpl<CSampleEveryDataPoint>,
	public IOleObjectImpl<CSampleEveryDataPoint>,
	public IOleInPlaceActiveObjectImpl<CSampleEveryDataPoint>,
	public IViewObjectExImpl<CSampleEveryDataPoint>,
	public IOleInPlaceObjectWindowlessImpl<CSampleEveryDataPoint>,
	public ISupportErrorInfo,
	public IPersistStorageImpl<CSampleEveryDataPoint>,
	public ISpecifyPropertyPagesImpl<CSampleEveryDataPoint>,
	public IQuickActivateImpl<CSampleEveryDataPoint>,
#ifndef _WIN32_WCE
	public IDataObjectImpl<CSampleEveryDataPoint>,
#endif
	public IProvideClassInfo2Impl<&CLSID_SampleEveryDataPoint, NULL, &LIBID_SampleAxControlVS2005Lib>,
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	public IObjectSafetyImpl<CSampleEveryDataPoint, INTERFACESAFE_FOR_UNTRUSTED_CALLER>,
#endif
	public CComCoClass<CSampleEveryDataPoint, &CLSID_SampleEveryDataPoint>,
	public CComControl<CSampleEveryDataPoint>,
  public IPersistPropertyBagImpl<CSampleEveryDataPoint>, // Step 1: Implement this to save attributes of display in IADS
  public IAcceptIadsParameter,  // Step 2: Implement this to accept a parameter for every data sample
  public ISynchronizeOutput // Step 3: Implement this to get time and be driven my IADS with all of the other displays (like stripchart)
{
public:


	CSampleEveryDataPoint()
	{
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_INSIDEOUT |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_SAMPLEEVERYDATAPOINT)


BEGIN_COM_MAP(CSampleEveryDataPoint)
	COM_INTERFACE_ENTRY(ISampleEveryDataPoint)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
#ifndef _WIN32_WCE
	COM_INTERFACE_ENTRY(IDataObject)
#endif
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	COM_INTERFACE_ENTRY_IID(IID_IObjectSafety, IObjectSafety)
#endif
  COM_INTERFACE_ENTRY(IPersistPropertyBag)   // Step 4: <- Don't forget these here.. or the QueryInterface will fail
	COM_INTERFACE_ENTRY(IAcceptIadsParameter)  // Step 5: <- 
  COM_INTERFACE_ENTRY(ISynchronizeOutput)    // Step 6: <- 
END_COM_MAP()

BEGIN_PROP_MAP(CSampleEveryDataPoint)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()


BEGIN_MSG_MAP(CSampleEveryDataPoint)
	CHAIN_MSG_MAP(CComControl<CSampleEveryDataPoint>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] =
		{
			&IID_ISampleEveryDataPoint,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

  // IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

  // ISampleEveryDataPoint
public:

  // Step 7: Add all these member variables
  IParameter*           mParameters[1];         // Array to hold parameters attached to this display. If you need more attached parameters, increase this value
  VARIANT_BOOL          mIsRealTime;            // Is the user streaming or scrolling back (with scrollbar)
  CComVariant           mSafeArrayOfDataValues; // Array to hold streaming data
  CComVariant           mSafeArrayOfTimeValues; // Array to hold streaming time
  IIadsTime*            mCurrentTime;           // Current time

  double                mValueToDisplay;        // For demo only. Value to output to the screen
  unsigned int          mLastValue;             // For demo only. Value to track ramp data for confirmation of every data point

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
    // Step 8: Initialize all the variables
    mCurrentTime = NULL;
    memset( mParameters, 0, sizeof(mParameters) );
    ::CoCreateInstance( CLSID_IadsTime, NULL, CLSCTX_ALL, IID_IIadsTime, (void**)&mCurrentTime );
    mValueToDisplay = 0.0;
    mLastValue = 0;
		return S_OK;
	}

	void FinalRelease()
	{
    // Step 9: Release current time when display is deleted
    if ( mCurrentTime ) mCurrentTime->Release();
	}

  // Step 10: If you need to display any graphics, it can be done here
  // It's also possible to output graphics in your "PrepareOutput" function below
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
	  RECT& rc = *(RECT*)di.prcBounds;

    // Set Clip region to the rectangle specified by di.prcBounds
	  HRGN hRgnOld = NULL;
	  if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
		  hRgnOld = NULL;
	  bool bSelectOldRgn = false;
	  HRGN hRgnNew = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);
	  if (hRgnNew != NULL)
	  {
		  bSelectOldRgn = (SelectClipRgn(di.hdcDraw, hRgnNew) != ERROR);
	  }

    // Draw a rectangle around our text
	  Rectangle( di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom );
	  SetTextAlign( di.hdcDraw, TA_CENTER|TA_BASELINE );
	  
    // Output our value to the screen
    char output[501];
    _snprintf( output, 500, "%f", mValueToDisplay );
	  TextOut( di.hdcDraw, (rc.left + rc.right) / 2, (rc.top + rc.bottom) / 2, output, lstrlen(output) );

    // Undo the clipping region
	  if (bSelectOldRgn)
		  SelectClipRgn(di.hdcDraw, hRgnOld);
    if ( hRgnNew ) DeleteObject( hRgnNew );

		return S_OK;
	}

  // IAcceptIadsParameter interface implementation: IADS specific interface to attach and remove parameters in the display

  // Step 11: Implement get_AttachPointCount function from the IAcceptIadsParameter interface
  // The Iads Container will call this function to determine how many attach points are assigned to this display 
  // Essentially, one attach point = 1 parameter slow, similar to creating a property
  STDMETHODIMP get_AttachPointCount( /*[out,retval]*/ long* pVal )
  {
    if ( !pVal ) return E_POINTER;
    *pVal = 1; // One "attachPoint" will give us a location to attach a single parameter  
    return S_OK;
  }

  // Step 12: Implement AttachPointName function from the IAcceptIadsParameter interface
  // The Iads container will give us an index and we need to return Ascii name for that index. 
  // These name(s) will be shown on the popup menu after parameter is dropped. Again, akin to properties
  STDMETHODIMP AttachPointName( /*[in]*/ long index, /*[out,retval]*/BSTR* ppItem )
  {
    if ( !ppItem ) return E_POINTER;
    if ( index > 1 ) return E_INVALIDARG; // Only one attachPoint in this display  

    // Return the attachPoint name for the index. If you change this name, don't forget to change the name below in the "Add" function
    *ppItem = ::SysAllocString( L"EveryDataPoint" ); 
    return *ppItem ? S_OK : E_OUTOFMEMORY;
  }

  // Step 13: Implement get_AttachPointDepth function from the IAcceptIadsParameter interface
  // The Iads container will call this to determine how many parameters needed to complete this attachPoint
  // For most displays, this value will be 1. 
  STDMETHODIMP get_AttachPointDepth( /*[in]*/ long index, /*[out,retval]*/long* pVal )
  {
    if ( !pVal ) return E_POINTER;
    *pVal = 1;  // A single parameter per attach point. This is the usual implementation
    return S_OK;
  }

  // Step 14: Implement get_Count function from the IAcceptIadsParameter interface
  // Return the number of attached parameters here. At this point, just return same as get_AttachPointCount
  STDMETHODIMP get_Count( /*[out, retval]*/ long* pVal )
  {
    if ( !pVal ) return E_POINTER;
    *pVal = 1; 
    return S_OK;
  }

  // Step 15: Implement get__NewEnum function from the IAcceptIadsParameter interface
  // Function for VB type interfaces. Return E_NOTIMPL here
  STDMETHODIMP get__NewEnum( /*[out, retval]*/ IUnknown** ppVal )
  {
    return E_NOTIMPL;  // Later for VB clients
  }

  // Step 16: Implement Item function from the IAcceptIadsParameter interface
  // The Iads container will call this function to retrieve the parameter at a given index
  STDMETHODIMP Item( /*[in]*/ VARIANT AttachPointNameOrIndex, /*[in,optional,defaultvalue(0)]*/ long AttachPointDepthIndex, /*[out,retval]*/ IParameter** ppItem )
  {
    // Handle queries of our parameter list of type VT_I4 (zero based index) and VT_BSTR (name of attachPoint)
    if ( AttachPointNameOrIndex.vt == VT_I4 ) 
    {
      LONG index = AttachPointNameOrIndex.lVal;

      // Check if requested index is in range of parameter attachments. Return E_INVALIDARG if out of bounds..
      if ( index < 0 || index > 0 ) return E_INVALIDARG;  

      // Now return a reference to our parameter
      *ppItem = mParameters[index];
      if ( mParameters[index] ) mParameters[index]->AddRef();  // Add a ref count so it doesn't get deleted
      return S_OK;
    }
    else if ( AttachPointNameOrIndex.vt == VT_BSTR )
    {
      // Get the index from the AttachPointName
      if ( wcscmp(AttachPointNameOrIndex.bstrVal,L"EveryDataPoint") == 0 )
      {
        *ppItem = mParameters[0];
        if ( mParameters[0] ) mParameters[0]->AddRef();  // Add a ref count so it doesn't get deleted
        return S_OK;
      }
    }

    return E_FAIL;
  }

  // Step 17: Implement Remove function from the IAcceptIadsParameter interface
  // The Iads container will call this function to remove a parameter at a given index
  STDMETHODIMP Remove( /*[in]*/ VARIANT AttachPointNameOrIndexOrObject, /*[in,optional,defaultvalue(0)]*/long AttachPointDepthIndex )  // ?? by [in] VARIANT indexOrName???
  {
    if ( AttachPointNameOrIndexOrObject.vt == VT_I4 ) 
    {
      LONG index = AttachPointNameOrIndexOrObject.lVal;

      // Check if requested index is in range of parameter attachments. Return E_INVALIDARG if out of bounds..
      if ( index < 0 || index > 0 ) return E_INVALIDARG;  

      if ( mParameters[0] != NULL )
      {
        mParameters[index]->Release();  // Release our reference count to the parameter
        mParameters[index] = NULL;  // Set the parameter to NULL
      }  
      return S_OK;
    }
    else if ( AttachPointNameOrIndexOrObject.vt == VT_BSTR ) 
    {
      // Get the index from the AttachPointName
      if ( wcscmp(AttachPointNameOrIndexOrObject.bstrVal,L"EveryDataPoint") == 0 )
      {
        mParameters[0]->Release();  // Release our reference count to the parameter
        mParameters[0] = NULL;  // Set the parameter to NULL
      }
    }

    return E_FAIL;
  }

  // Step 18: Implement RemoveAll function from the IAcceptIadsParameter interface
  // The Iads container will call this to remove all parameters from a display
  STDMETHODIMP RemoveAll()
  {
    // Release our reference count all parameters here
    if ( mParameters[0] != NULL )
    {
      mParameters[0]->Release();  
      mParameters[0] = NULL;  // Set the parameters to NULL
    }
    return S_OK;
  }

  // Step 19: Implement Add function from the IAcceptIadsParameter interface
  // The Iads container will call this function when a user drops a parameter on your display
  STDMETHODIMP Add( /*[in]*/IParameter* newVal, /*[in,optional,defaultvalue("(null)")]*/BSTR AttachPointName, /*[in,optional,defaultvalue(0)]*/long AttachPointDepthIndex )
  {
    if ( !newVal ) return E_POINTER;

    // Get the index from the AttachPointName
    if ( wcscmp(AttachPointName,L"EveryDataPoint") != 0 )
      return E_INVALIDARG;

    // Release old parameter at this index, if exists..
    if ( mParameters[0] ) mParameters[0]->Release();

    mParameters[0] = newVal;  // Grab new parameter
    newVal->AddRef();         // Add a ref..

    this->FireViewChange();   // Force a redraw of our display
    m_bRequiresSave = TRUE;   // Dirty our display so it'll get saved...
    return S_OK; 
  }

  // ISynchronizeOutput interface implementation: IADS specific interface to synchronize drawing and data output with other displays on the screen

  // Step 20: Implement PrepareOutput function from the ISynchronizeOutput interface
  // Iads calls this function when a display is to be updated. Included is the current time of the AnalysisWindow (parentContainerTime)
  // as well as the global time on the dashboard
  STDMETHODIMP PrepareOutput( /*[in]*/IIadsTime* parentContainerTime, /*[in]*/IIadsTime* globalTime )
  {
    // Step 21. Check input variables for validity
    if ( !parentContainerTime || !globalTime ) return E_POINTER;

    // Step 22. Set our current time variable. You can use this for a time display, etc
    if ( this->mCurrentTime->SetTime(parentContainerTime) != S_OK ) return E_UNEXPECTED;

    // Step 23. Check to see if a parameter is attached. If not just return.
    if ( mParameters[0] == NULL ) return S_OK;

    // Step 24. Check to see if the user is in scroll back mode (and thus the time could be randomly jumping)
    //          or the display is streaming data at the current time
    if ( mIsRealTime == VARIANT_FALSE )
    {
      // The user is scrolling back with the scrollbar, so let's just read data from the current time
      // Depending on your display needs, you could actually read a block of data from the current time for N seconds

      // Set the current time in the parameter 
      mParameters[0]->put_CurrentTime( parentContainerTime );

      // Now get the value from the parameter
      CComVariant dataValue;
      mParameters[0]->Value2( iadsTimeNoChange, &dataValue, NULL/*OptionTimeReturn*/ );
      
      // Extract the value from the variant returned
      mValueToDisplay = GetVariantValueHelper( dataValue );
      this->FireViewChange(); // Ask that our display be redrawn with the new value

      // Reset the state of the streaming frame read
      mParameters[0]->put_HaveStartedFrameRead( VARIANT_FALSE );
      return S_OK;
    }

    // Now here comes the fun part... We now have to focus on processing of "EveryDataPoint"
    // This is where we make use the functions: StartFrameRead, GetNextFrameRead. 
    // The functions will help supply the new data block from the last time we've read to the current time

    // Step 25. Check to see if we've started streaming data. If not, simply initialize the start time and return
    VARIANT_BOOL haveStartedStreaming;
    mParameters[0]->get_HaveStartedFrameRead( &haveStartedStreaming );
    if ( !haveStartedStreaming )
    {
      // Initialize the frame read with the start time and maximum amount of data per read.
      // In this example, MaxSecondsPerFrame is set to 5 seconds. Keep this value resonable to protect against a time jump. 
      // For example, let's say time just randomly jumps an hour. In that case your display will attempt to process 1 hour 
      // of data and most likely lock up everything. Setting this value to something reasonable prevents this situation.
      // In most cases, the time jump between successive calls to this display is much less than a tenth of a second... 
      // so 5 seconds will give more than enough leeway
      mParameters[0]->StartFrameRead( parentContainerTime, 5.0 );

      // Temporary fix for using blob types with StartFrameRead/NextFrameRead. Will be unnecessary soon
      IadsParameterDataType pt;
      mParameters[0]->get_DataType( &pt );
      if ( pt == iadsBlobData )
        mParameters[0]->put_VBScriptDataCompatibility( VARIANT_TRUE );

      return S_OK;
    }

    // Step 26. Read the frame of data from the last time to the current time. 
    LONG numValuesReturned = 0;
    HRESULT hr = mParameters[0]->GetNextFrameRead( parentContainerTime, &mSafeArrayOfDataValues, &numValuesReturned, NULL/*If you want time per data point, uncomment this &mSafeArrayOfTimeValues*/ );
    if ( hr != S_OK ) 
    {
      // If GetNextFrameReadFails for any reason, reset the frame reading sequence
      mParameters[0]->StartFrameRead( parentContainerTime, 5.0 );
      return S_OK;
    }

    // Step 27. If the number of points returned are zero (which could happen if the display is updating faster than the sample
    //          rate of the parameter, then simply return and wait for the next pass
    if ( numValuesReturned <= 0 )
      return S_OK;

    // Step 29: The data from the GetNextFrameRead is actually a Variant "SafeArray" of values from the last time we called the 
    // function, to this current time. The Variant type denotes the time of individual element. Each Iads dataType provides a unique
    // type. For example, if your Iads parameter is of type "float", the SafeArray will contain an array of VT_R4 elements (float32).
    // The example below will show how to extract each type of data.
    // As for processing every data point, the GetNextFrameRead technique makes it very easy. If you process each element of the 
    // return array every pass, you'll will have then processed all of the data the parameter supplies as the display streams along.
    // Of course we will be unable to display every value in this example (text output), so if you want to show all the data
    // you'll need present the data using another mechanism such as a scrolled list or stripchart like display. 
    // If you're processing all the data to search for a specific event, simply search through all the data using 
    // a similar loop and update your graphical display accordingly.
    // For now, let's compute the max of all values processed and display the max in the text object. 
    void* da = (void*)mSafeArrayOfDataValues.parray->pvData;
    VARTYPE dataType = mSafeArrayOfDataValues.vt & VT_TYPEMASK;

    // Step 30. Process every data point in a loop. For now, let's compute the max of all values found and display 
    // If you want to be able to process all Iads parameter types, you'll need to check the base data 
    // type and process accordingly. As an example, I wrote a function called GetArrayValueHelper that will detail
    // how to extract each different data type. If you're only expecting one particular type, you can pick one of the cases
    // inside the GetArrayValueHelper and move the code here
    // If you are processing blob data, see the ProcessBlobData function below
    if ( mSafeArrayOfDataValues.vt != (VT_VARIANT|VT_ARRAY) )
    {
      register double max = 0.0;
      for ( int i = 0; i < numValuesReturned; i++ )
      {
        register double value = GetArrayValueHelper( dataType, da, i );
        if ( i == 0 ) max = value;
        if ( value > max ) max = value;
      }
      mValueToDisplay = max;
    }
    else
    {
      // Special Blob processing for this example
      ProcessBlobData( numValuesReturned );
    }

    // Step 31. Now that we have a value to display, force an update of our display. 
    // This will cause the "OnDraw" function to be called. In this case we'll simply display the value of mValueToDisplay
    this->FireViewChange();
 
    return S_OK;
  }

  // Step 32: Implement PerformOutput function from the ISynchronizeOutput interface 
  STDMETHODIMP PerformOutput()
  {
    // If our display was "DoubleBuffered", we would do our final "PageFlip/Bitblit" output here....
    // We really don't need the function for this particular display (Unless we double buffered the text output)
    // Do all of the drawing in OnDraw..
    return S_OK;
  }

  // Step 33: Implement put_IsRealTime function from the ISynchronizeOutput interface 
  // When the user stops the display or continues back to streaming mode, this function will be called
  STDMETHODIMP put_IsRealTime( /*[in]*/ VARIANT_BOOL isRealTime )
  {
    if ( mIsRealTime == isRealTime ) return S_OK;

    // RealTime state changed here... For now, just set the member variable. 
    // "RealTime = VARIANT_TRUE means that the user is running the display continuously updating from the IADS clock
    // "RealTime = VARIANT_FALSE means that the user is paused or is in "scrollback" mode, updating from the analysis window's scrollbar position
    mIsRealTime = isRealTime;
    return S_OK;
  }

  // Helper function to demonstrate extracting data from the returned array. For long/ulong/blob/ascii it might be best to create other function(s)
  double GetArrayValueHelper( VARTYPE dataType, void* dataArray, int index )
  {
    if ( dataType == VT_R4 )
    {
      // If parameter type is "float", the variant dataType is type VT_R4, and the base type is "float" 
      float* da = (float*)dataArray;
      return (double)da[index];
    }
    else if ( dataType == VT_R8 )
    {
      // If parameter type is "double", the variant dataType is type VT_R8, and the base type is "double" 
      double* da = (double*)dataArray;
      return (double)da[index];
    }
    else if ( dataType == VT_I4 )
    {
      // If parameter type is "int", the variant dataType is type VT_I4, and the base type is "__int32" 
      __int32* da = (__int32*)dataArray;
      return (double)da[index];
    }
    else if ( dataType == VT_UI4 )
    {
      // If parameter type is "discrete", the variant dataType is type VT_UI4, and the base type is "unsigned __int32" 
      unsigned __int32* da = (unsigned __int32*)dataArray;
      return (double)da[index];
    }
    else if ( dataType == VT_I8 )
    {
      // If parameter type is "long", the variant dataType is type VT_I8, and the base type is "__int64" 
      __int64* da = (__int64*)dataArray;
      return (double)da[index]; // Warning. This will most likely loose precision. Create a new function if processing ulong data
    }
    else if ( dataType == VT_UI8 )
    {
      // If parameter type is "ulong", the variant dataType is type VT_UI8, and the base type is "unsigned __int64" 
      unsigned __int64* da = (unsigned __int64*)dataArray;
      return (double)(__int64)da[index]; // Warning. This will most likely loose precision. Create a new function if processing ulong data
    }
    else if ( dataType == VT_BSTR )
    {
      // If parameter type is "ascii", the variant dataType is type VT_BSTR, and the base type is "VARIANT bstrVal" 
      VARIANT* da = (VARIANT*)dataArray;
      wchar_t* pos;
      return wcstod( (wchar_t*)da[index].bstrVal, &pos ); // Create a new function if processing ascii exclusively
    }
    else if ( dataType == (VT_UI1|VT_ARRAY) )
    {
      // If parameter type is "blob", the variant dataType is type VT_VARIANT, and the base type is "VARIANT VT_UI1|VT_ARRAY" 
      // Blob data is packaged in a safearray of bytes. The first 4 bytes are an integer that denotes the size of the array
      VARIANT* da = (VARIANT*)dataArray;

      // Extract the safearray and then the byte point to the blob
      SAFEARRAY* sa = da[index].parray;
        
      // Extract the number of bytes in this blob/array. The size is the value of the unsigned int in the first 4 bytes
      unsigned __int32 numBytesInBlob = *((unsigned __int32*)sa->pvData);

      // Extract the data.. 4 bytes passed the head of the blob
      BYTE* data = (BYTE*)sa->pvData + sizeof(unsigned __int32); 

      // For now, just find the max of all bytes in blob
      BYTE max = 0;
      for( register unsigned int i=0; i<numBytesInBlob; i++ )
      {
        if ( i == 0 ) max = data[i];
        if ( data[i] > max ) max = data[i];
      }
      return (double)max; // Create a new function if processing blobs exclusively
    }
    else if ( dataType == VT_VARIANT )
    {
      // If VBCompatability mode is true, the base type is "VARIANT"
      VARIANT* da = (VARIANT*)dataArray;
      CComVariant v;
      v.Copy( &da[index] );
      v.ChangeType( VT_R8 );
      return v.dblVal;
    }
    return 0.0;
  }

  // Helper function to demonstrate extracting data from a variant. For long/ulong/blob/ascii it might be best to create other function(s)
  double GetVariantValueHelper( VARIANT& v )
  {
    switch( v.vt )
    {
      case VT_R8:  return v.dblVal;
      case VT_R4:  return (double)v.fltVal;
      case VT_INT:
      case VT_I4:  return (double)v.lVal;
      case VT_UI4: return (double)v.ulVal;
      case VT_I2:  return (double)v.iVal;
      case VT_UI2: return (double)v.uiVal;
      case VT_I1:
      case VT_UI1: return (double)v.bVal;
      case VT_I8:  return (double)v.llVal;
      case VT_UI8: return (double)(__int64)v.ullVal; // This conversion could loose precision
    }

    VARIANT v2; 
    if ( ::VariantChangeType(&v2,&v,VARIANT_ALPHABOOL,VT_R8) != S_OK ) 
      return 0.0;
    return v2.dblVal;
  }

  // Example of processing blob data in a loop. This particular code verifies every data sample using a special
  // data set that produces blob with ramp data. See below for location on where to inject your own code
  void ProcessBlobData( int numBlobsInArray )
  {
    VARIANT* da = (VARIANT*)mSafeArrayOfDataValues.parray->pvData;
    VARTYPE dataType = mSafeArrayOfDataValues.vt & VT_TYPEMASK;

    for ( int index = 0; index < numBlobsInArray; index++ )
    {
      // Extract the safearray and then the byte point to the blob
      SAFEARRAY* sa = da[index].parray;
      if ( !sa ) continue;
        
      // Extract the number of bytes in this blob/array. The size is the value of the unsigned int in the first 4 bytes
      unsigned __int32 numBytesInBlob = *((unsigned __int32*)sa->pvData);

      // Extract the data.. 4 bytes past the head of the blob
      BYTE* data = (BYTE*)sa->pvData + sizeof(unsigned __int32); 

      // At this point, the "payload" of the blob is in the data array (numBytesInBlob length)
      // Add your processing code here and remove mine below
      
      // My processing code example for the blob. In my case, I have blob test data that contains
      // an incrementing ramp value within the blob data. If there's a discontinuity, output a debug message 
      int numIntsInBlob = numBytesInBlob / sizeof(unsigned __int32);
      unsigned __int32* dataArray = (unsigned __int32*)data;
      for( register int i=0; i<numIntsInBlob; i++ )
      {
        if ( mLastValue == 0 ) break;
        if ( dataArray[i] != (mLastValue+1) )
        {
          char m[500];
          sprintf( m, "Every data point error lastValue = %d  currentValue = %d\n", mLastValue, dataArray[i] );
          ::OutputDebugString( m );
          break;
        }
      }
      mLastValue = dataArray[0];
      mValueToDisplay = (double)mLastValue; // Create a new function if processing blobs exclusively
    }
  }

};

OBJECT_ENTRY_AUTO(__uuidof(SampleEveryDataPoint), CSampleEveryDataPoint)
