// *****************************************************************************
//
// Copyright. 2007. Symvionics, Inc. All rights reserved.
// 
// Symvionics Inc. ("Symvionics") grants a non-exclusive license for you to use
// and redistribute this software, in both source code and binary forms, and the
// accompanying documentation, if any, free of charge, provided that this
// paragraph, and the following two paragraphs appear in all copies and in all
// derivative works.  In no event shall this source code or this license thereto
// impact upon or fall within the scope of any otheragreement that you have with
// Symvionics.
// 
// BY USING THIS SOFTWARE, YOU FURTHER AGREE THAT, IN NO EVENT, SHALL SYMVIONICS
// BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
// CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
// SOFTWARE, THE ACCOMPANYING DOCUMENTATION, IF ANY, OR ANY DERIVATIVE WORKS.
// YOU AGREE TO DEFEND, INDEMNIFY, AND HOLD HARMLESS SYMVIONICS FROM AND AGAINST
// ALL FINES, PENALTIES, LIABILITIES, DAMAGES, COSTS, AND EXPENSES INCURRED
// BY SYMVIONICS AS A RESULT OF YOUR USE OF THIS SOFTWARE INCLUDING THIRD PARTY
// USE OF ANY DERIVATIVE WORKS CREATED BY YOU.
// 
// SYMVIONICS SPECIFICALLY DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
// PARTICULAR PURPOSE.  THE SOFTWARE AND ACCOMPANYING DOCUMENTATION LICENSED
// HEREUNDER ARE PROVIDED "AS IS" WITHOUT WARRANTY OR OBLIGATION OF SUPPORT OR 
// MAINTENANCE.
//
// *****************************************************************************
// SampleEveryDataPoint2.h : Declaration of the CSampleEveryDataPoint2

// This example shows how to program an every data point display without the use of StartFrameRead/GetNextFrameRead functions
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "SampleAxControlVS2005.h"

// Add Iads.idl and IadsTime.idl to the project (as the tutorial shows). After that is complete, Add these to the include files
#include "Iads.h"           
#include "IadsTime.h"       

// Add these files to the stdafx.cpp file
//#include "Iads.h"         
//#include "Iads_i.c"
//#include "IadsTime.h"
//#include "IadsTime_i.c"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif


// CSampleEveryDataPoint2
class ATL_NO_VTABLE CSampleEveryDataPoint2 :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISampleEveryDataPoint2, &IID_ISampleEveryDataPoint2, &LIBID_IadsAutomationLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<CSampleEveryDataPoint2>,
	public IOleControlImpl<CSampleEveryDataPoint2>,
	public IOleObjectImpl<CSampleEveryDataPoint2>,
	public IOleInPlaceActiveObjectImpl<CSampleEveryDataPoint2>,
	public IViewObjectExImpl<CSampleEveryDataPoint2>,
	public IOleInPlaceObjectWindowlessImpl<CSampleEveryDataPoint2>,
	public ISupportErrorInfo,
	public IPersistStorageImpl<CSampleEveryDataPoint2>,
	public ISpecifyPropertyPagesImpl<CSampleEveryDataPoint2>,
	public IQuickActivateImpl<CSampleEveryDataPoint2>,
#ifndef _WIN32_WCE
	public IDataObjectImpl<CSampleEveryDataPoint2>,
#endif
	public IProvideClassInfo2Impl<&CLSID_SampleEveryDataPoint2, NULL, &LIBID_IadsAutomationLib>,
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	public IObjectSafetyImpl<CSampleEveryDataPoint2, INTERFACESAFE_FOR_UNTRUSTED_CALLER>,
#endif
	public CComCoClass<CSampleEveryDataPoint2, &CLSID_SampleEveryDataPoint2>,
	public CComControl<CSampleEveryDataPoint2>,
  public IPersistPropertyBagImpl<CSampleEveryDataPoint2>, // Step 1: Implement this to save attributes of display in IADS
  public IAcceptIadsParameter,  // Step 2: Implement this to accept a parameter for every data sample
  public ISynchronizeOutput // Step 3: Implement this to get time and be driven my IADS with all of the other displays (like stripchart)
{
public:


	CSampleEveryDataPoint2()
	{
	}

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_INSIDEOUT |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_SAMPLEEVERYDATAPOINT2)


BEGIN_COM_MAP(CSampleEveryDataPoint2)
	COM_INTERFACE_ENTRY(ISampleEveryDataPoint2)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
#ifndef _WIN32_WCE
	COM_INTERFACE_ENTRY(IDataObject)
#endif
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	COM_INTERFACE_ENTRY_IID(IID_IObjectSafety, IObjectSafety)
#endif
  COM_INTERFACE_ENTRY(IPersistPropertyBag)   // Step 4: <- Don't forget these here.. or the QueryInterface will fail
	COM_INTERFACE_ENTRY(IAcceptIadsParameter)  // Step 5: <- 
  COM_INTERFACE_ENTRY(ISynchronizeOutput)    // Step 6: <- 
END_COM_MAP()

BEGIN_PROP_MAP(CSampleEveryDataPoint2)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()


BEGIN_MSG_MAP(CSampleEveryDataPoint2)
	CHAIN_MSG_MAP(CComControl<CSampleEveryDataPoint2>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] =
		{
			&IID_ISampleEveryDataPoint2,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)


  // Step 7: Add all these member variables
  IParameter*           mParameters[1];         // Array to hold parameters attached to this display. If you need more attached parameters, increase this value
  VARIANT_BOOL          mIsRealTime;            // Is the user streaming or scrolling back (with scrollbar)
  IIadsTime*            mCurrentTime;           // Current time
  IIadsTime*            mLastTime;              // Last time processed
  IIadsTime*            mDataTime;              // Time of current data point
  VARIANT_BOOL          mHaveStartedFrameRead;  // Flag to determine if we've started processing data

  double                mValueToDisplay;        // For demo only. Value to output to the screen
  unsigned int          mLastValue;             // For demo only. Value to track ramp data for confirmation of every data point


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
    // Step 8: Initialize all the variables
    mCurrentTime = NULL;
    mLastTime = NULL;
    memset( mParameters, 0, sizeof(mParameters) );
    ::CoCreateInstance( CLSID_IadsTime, NULL, CLSCTX_ALL, IID_IIadsTime, (void**)&mCurrentTime );
    ::CoCreateInstance( CLSID_IadsTime, NULL, CLSCTX_ALL, IID_IIadsTime, (void**)&mLastTime );
    ::CoCreateInstance( CLSID_IadsTime, NULL, CLSCTX_ALL, IID_IIadsTime, (void**)&mDataTime );
    mValueToDisplay = 0.0;
    mLastValue = 0;
    mHaveStartedFrameRead = VARIANT_FALSE;
		return S_OK;
	}

	void FinalRelease()
	{
    // Step 9: Release current time when display is deleted
    if ( mCurrentTime ) mCurrentTime->Release();
    if ( mLastTime ) mLastTime->Release();
    if ( mDataTime ) mDataTime->Release();
	}

  // Step 10: If you need to display any graphics, it can be done here
  // It's also possible to output graphics in your "PrepareOutput" function below
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
	  RECT& rc = *(RECT*)di.prcBounds;

    // Set Clip region to the rectangle specified by di.prcBounds
	  HRGN hRgnOld = NULL;
	  if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
		  hRgnOld = NULL;
	  bool bSelectOldRgn = false;
	  HRGN hRgnNew = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);
	  if (hRgnNew != NULL)
	  {
		  bSelectOldRgn = (SelectClipRgn(di.hdcDraw, hRgnNew) != ERROR);
	  }

    // Draw a rectangle around our text
	  Rectangle( di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom );
	  SetTextAlign( di.hdcDraw, TA_CENTER|TA_BASELINE );
	  
    // Output our value to the screen
    char output[501];
    _snprintf( output, 500, "%f", mValueToDisplay );
	  TextOut( di.hdcDraw, (rc.left + rc.right) / 2, (rc.top + rc.bottom) / 2, output, lstrlen(output) );

    // Undo the clipping region
	  if (bSelectOldRgn)
		  SelectClipRgn(di.hdcDraw, hRgnOld);
    if ( hRgnNew ) DeleteObject( hRgnNew );

		return S_OK;
	}

  // IAcceptIadsParameter interface implementation: IADS specific interface to attach and remove parameters in the display

  // Step 11: Implement get_AttachPointCount function from the IAcceptIadsParameter interface
  // The Iads Container will call this function to determine how many attach points are assigned to this display 
  // Essentially, one attach point = 1 parameter slow, similar to creating a property
  STDMETHODIMP get_AttachPointCount( /*[out,retval]*/ long* pVal )
  {
    if ( !pVal ) return E_POINTER;
    *pVal = 1; // One "attachPoint" will give us a location to attach a single parameter  
    return S_OK;
  }

  // Step 12: Implement AttachPointName function from the IAcceptIadsParameter interface
  // The Iads container will give us an index and we need to return Ascii name for that index. 
  // These name(s) will be shown on the popup menu after parameter is dropped. Again, akin to properties
  STDMETHODIMP AttachPointName( /*[in]*/ long index, /*[out,retval]*/BSTR* ppItem )
  {
    if ( !ppItem ) return E_POINTER;
    if ( index > 1 ) return E_INVALIDARG; // Only one attachPoint in this display  

    // Return the attachPoint name for the index. If you change this name, don't forget to change the name below in the "Add" function
    *ppItem = ::SysAllocString( L"EveryDataPoint" ); 
    return *ppItem ? S_OK : E_OUTOFMEMORY;
  }

  // Step 13: Implement get_AttachPointDepth function from the IAcceptIadsParameter interface
  // The Iads container will call this to determine how many parameters needed to complete this attachPoint
  // For most displays, this value will be 1. 
  STDMETHODIMP get_AttachPointDepth( /*[in]*/ long index, /*[out,retval]*/long* pVal )
  {
    if ( !pVal ) return E_POINTER;
    *pVal = 1;  // A single parameter per attach point. This is the usual implementation
    return S_OK;
  }

  // Step 14: Implement get_Count function from the IAcceptIadsParameter interface
  // Return the number of attached parameters here. At this point, just return same as get_AttachPointCount
  STDMETHODIMP get_Count( /*[out, retval]*/ long* pVal )
  {
    if ( !pVal ) return E_POINTER;
    *pVal = 1; 
    return S_OK;
  }

  // Step 15: Implement get__NewEnum function from the IAcceptIadsParameter interface
  // Function for VB type interfaces. Return E_NOTIMPL here
  STDMETHODIMP get__NewEnum( /*[out, retval]*/ IUnknown** ppVal )
  {
    return E_NOTIMPL;  // Later for VB clients
  }

  // Step 16: Implement Item function from the IAcceptIadsParameter interface
  // The Iads container will call this function to retrieve the parameter at a given index
  STDMETHODIMP Item( /*[in]*/ VARIANT AttachPointNameOrIndex, /*[in,optional,defaultvalue(0)]*/ long AttachPointDepthIndex, /*[out,retval]*/ IParameter** ppItem )
  {
    // Handle queries of our parameter list of type VT_I4 (zero based index) and VT_BSTR (name of attachPoint)
    if ( AttachPointNameOrIndex.vt == VT_I4 ) 
    {
      LONG index = AttachPointNameOrIndex.lVal;

      // Check if requested index is in range of parameter attachments. Return E_INVALIDARG if out of bounds..
      if ( index < 0 || index > 0 ) return E_INVALIDARG;  

      // Now return a reference to our parameter
      *ppItem = mParameters[index];
      if ( mParameters[index] ) mParameters[index]->AddRef();  // Add a ref count so it doesn't get deleted
      return S_OK;
    }
    else if ( AttachPointNameOrIndex.vt == VT_BSTR )
    {
      // Get the index from the AttachPointName
      if ( wcscmp(AttachPointNameOrIndex.bstrVal,L"EveryDataPoint") == 0 )
      {
        *ppItem = mParameters[0];
        if ( mParameters[0] ) mParameters[0]->AddRef();  // Add a ref count so it doesn't get deleted
        return S_OK;
      }
    }

    return E_FAIL;
  }

  // Step 17: Implement Remove function from the IAcceptIadsParameter interface
  // The Iads container will call this function to remove a parameter at a given index
  STDMETHODIMP Remove( /*[in]*/ VARIANT AttachPointNameOrIndexOrObject, /*[in,optional,defaultvalue(0)]*/long AttachPointDepthIndex )  // ?? by [in] VARIANT indexOrName???
  {
    if ( AttachPointNameOrIndexOrObject.vt == VT_I4 ) 
    {
      LONG index = AttachPointNameOrIndexOrObject.lVal;

      // Check if requested index is in range of parameter attachments. Return E_INVALIDARG if out of bounds..
      if ( index < 0 || index > 0 ) return E_INVALIDARG;  

      if ( mParameters[0] != NULL )
      {
        mParameters[index]->Release();  // Release our reference count to the parameter
        mParameters[index] = NULL;  // Set the parameter to NULL
      }  
      return S_OK;
    }
    else if ( AttachPointNameOrIndexOrObject.vt == VT_BSTR ) 
    {
      // Get the index from the AttachPointName
      if ( wcscmp(AttachPointNameOrIndexOrObject.bstrVal,L"EveryDataPoint") == 0 )
      {
        mParameters[0]->Release();  // Release our reference count to the parameter
        mParameters[0] = NULL;  // Set the parameter to NULL
      }
    }

    return E_FAIL;
  }

  // Step 18: Implement RemoveAll function from the IAcceptIadsParameter interface
  // The Iads container will call this to remove all parameters from a display
  STDMETHODIMP RemoveAll()
  {
    // Release our reference count all parameters here
    if ( mParameters[0] != NULL )
    {
      mParameters[0]->Release();  
      mParameters[0] = NULL;  // Set the parameters to NULL
    }
    return S_OK;
  }

  // Step 19: Implement Add function from the IAcceptIadsParameter interface
  // The Iads container will call this function when a user drops a parameter on your display
  STDMETHODIMP Add( /*[in]*/IParameter* newVal, /*[in,optional,defaultvalue("(null)")]*/BSTR AttachPointName, /*[in,optional,defaultvalue(0)]*/long AttachPointDepthIndex )
  {
    if ( !newVal ) return E_POINTER;

    // Get the index from the AttachPointName
    if ( wcscmp(AttachPointName,L"EveryDataPoint") != 0 )
      return E_INVALIDARG;

    // Release old parameter at this index, if exists..
    if ( mParameters[0] ) mParameters[0]->Release();

    mParameters[0] = newVal;  // Grab new parameter
    newVal->AddRef();         // Add a ref..

    mHaveStartedFrameRead = VARIANT_FALSE;
    this->FireViewChange();   // Force a redraw of our display
    m_bRequiresSave = TRUE;   // Dirty our display so it'll get saved...
    return S_OK; 
  }

  // ISynchronizeOutput interface implementation: IADS specific interface to synchronize drawing and data output with other displays on the screen

  // Step 20: Implement PrepareOutput function from the ISynchronizeOutput interface
  // Iads calls this function when a display is to be updated. Included is the current time of the AnalysisWindow (parentContainerTime)
  // as well as the global time on the dashboard
  STDMETHODIMP PrepareOutput( /*[in]*/IIadsTime* parentContainerTime, /*[in]*/IIadsTime* globalTime )
  {
    // Step 21. Check input variables for validity
    if ( !parentContainerTime || !globalTime ) return E_POINTER;

    // Step 22. Set our current time variable. You can use this for a time display, etc
    if ( this->mCurrentTime->SetTime(parentContainerTime) != S_OK ) return E_UNEXPECTED;

    // Step 23. Check to see if a parameter is attached. If not just return.
    if ( mParameters[0] == NULL ) return S_OK;

    // Step 24. Check to see if the user is in scroll back mode (and thus the time could be randomly jumping)
    //          or the display is streaming data at the current time
    if ( mIsRealTime == VARIANT_FALSE )
    {
      // The user is scrolling back with the scrollbar, so let's just read data from the current time
      // Depending on your display needs, you could actually read a block of data from the current time for N seconds

      // Set the current time in the parameter 
      mParameters[0]->put_CurrentTime( parentContainerTime );

      // Now get the value from the parameter
      CComVariant dataValue;
      mParameters[0]->Value2( iadsTimeNoChange, &dataValue, NULL/*OptionTimeReturn*/ );
      
      // Extract the value from the variant returned
      mValueToDisplay = GetVariantValueHelper( dataValue );
      this->FireViewChange(); // Ask that our display be redrawn with the new value

      mHaveStartedFrameRead = VARIANT_FALSE;
      return S_OK;
    }

    // Now here comes the fun part... We now have to focus on processing of "EveryDataPoint"

    // Step 25. Check to see if we've started streaming data. If not, simply initialize the start time and return
    if ( !mHaveStartedFrameRead )
    {
      // This is important piece of code to ensure every data sample on an aperiodic parameter without StartFrameRead/NextFrameRead
      VARIANT_BOOL isAperiodic = VARIANT_FALSE;
      mParameters[0]->get_IsAperiodic( &isAperiodic );
      if ( isAperiodic )
        mParameters[0]->put_InterpolatedSampleRate( 0.0 );

      // Keep track of the exact time we started to process data. We will need this as a starting point for the next display cycle
      mLastTime->SetTime( parentContainerTime );

      mHaveStartedFrameRead = VARIANT_TRUE;
      return S_OK;
    }

    // Step 26. Check whether the difference between the last processed time and current time is greater
    // than a pre-set limit (5 seconds). If so, don't process. The user may have jumped hours or days 
    // ahead in the data, so if we would lock up if we attempted to process this much data
    // Also check to see if time jumped backwards. If either case, mark the new time and start again
    int NumSecondsDiff = 0;
    parentContainerTime->TimeTicksBetween( mLastTime, 1.0, &NumSecondsDiff );
    if ( NumSecondsDiff > 5 )
    {
      mHaveStartedFrameRead = VARIANT_FALSE;
      return S_OK;
    }

    // Step 27. Read the frame of data from the last time to the current time. 
    // Set the current time in the parameter 
    HRESULT hr = mParameters[0]->put_CurrentTime( parentContainerTime );
    if ( hr != S_OK )
    {
      // If the put_CurrentTime fails, reset
      mHaveStartedFrameRead = VARIANT_FALSE;
      return S_OK;
    }

    // Now get the value and time from the parameter at this specific parentContainerTime. 
    // The time in the parameter may differ from the AnalysisWindow's notion of current time by 
    // a bit (especially if the parameter is aperiodic)
    CComVariant dataValueNotUsed;
    hr = mParameters[0]->Value2( iadsTimeNoChange, &dataValueNotUsed, &mCurrentTime );
    if ( hr != S_OK )
    {
      // If the Value2 fails, reset
      mHaveStartedFrameRead = VARIANT_FALSE;
      return S_OK;
    }
      
    // Check right off the bat to see if we've already processed this data point. If so, wait for more data..
    VARIANT_BOOL sameTimeAsLast = VARIANT_FALSE;
    mCurrentTime->IsEqual( mLastTime, &sameTimeAsLast );
    if ( sameTimeAsLast ) return S_OK;

    // Misc variables for the calculation below (only for this example)
    bool start = true;
    double max = 0.0;

    // Step 28. Process every data point in the loop until the time is equal to the most current value.
    // Set the current time in the parameter to the last time we've processed data.
    // After this is complete, we can read the data one point at a time until we reach the current time.
    hr = mParameters[0]->put_CurrentTime( mLastTime );
    if ( hr != S_OK )
    {
      // If the put_CurrentTime fails, reset
      mHaveStartedFrameRead = VARIANT_FALSE;
      return S_OK;
    }

    VARIANT_BOOL isEqualTo = VARIANT_FALSE;
    VARIANT_BOOL greaterThan = VARIANT_FALSE;
    do 
    {
      // Step 29. Get the data value from the parameter and ask it to advance to the next point (for the next pass in the loop)
      CComVariant dataValue;
      hr = mParameters[0]->Value2( iadsTimeAdvanceFoward, &dataValue, &mDataTime );
      if ( hr != S_OK )
      {
        // If the Value2 fails, break out. We're done for this pass
        break;
      }

      // Step 30. If the time returned is the same as the last pass (which could happen if the display is updating faster than the sample
      //          rate of the parameter), then simply return and wait for the next value
      VARIANT_BOOL isDataTimeLessThanLastTime = VARIANT_FALSE, isDataTimeEqualToLastTime = VARIANT_FALSE;
      mDataTime->IsLess( mLastTime, &isDataTimeLessThanLastTime );
      mDataTime->IsEqual( mLastTime, &isDataTimeEqualToLastTime );
      if ( isDataTimeLessThanLastTime || isDataTimeEqualToLastTime ) 
        continue; // Continue to the next value. We've already processed this one

      // Step 31. Finally, process the data. For now, let's compute get the max all values found and display.
      // If you want to be able to process all Iads parameter types, you'll need to check the base data 
      // type and process accordingly. As an example, I wrote a function called GetArrayValueHelper that will detail
      // how to extract each different data type. If you're only expecting one particular type, you can pick one of the cases
      // inside the GetArrayValueHelper and move the code here
      // If you are processing blob data, see the ProcessBlobData function below
      if ( dataValue.vt != (VT_ARRAY|VT_UI1) )
      {
        double value = GetVariantValueHelper( dataValue );
        if ( start )
        {
          max = value;
          start = false;
        }
        if ( value > max ) 
          max = value;
      }
      else
      {
        // Special Blob processing for this example
        ProcessBlobDataFromVariant( dataValue );
      }

      // Step 32. Important: Mark the last time we've processed 
      mLastTime->SetTime( mDataTime );

      // Step 33. Now, compare the dataTime to the currentTime. If it's equal or greater than, we're done for this pass
      mDataTime->IsEqual( mCurrentTime, &isEqualTo );
      mDataTime->IsGreater( mCurrentTime, &greaterThan );

    } while ( !isEqualTo && !greaterThan );

    // Set display value (max of all value for this section of time)
    if ( !start )
      mValueToDisplay = max;

    // Step 34. Now that we have a value to display, force an update of our display. 
    // This will cause the "OnDraw" function to be called. In this case we'll simply display the value of mValueToDisplay
    this->FireViewChange();
 
    return S_OK;
  }

  // Step 35: Implement PerformOutput function from the ISynchronizeOutput interface 
  STDMETHODIMP PerformOutput()
  {
    // If our display was "DoubleBuffered", we would do our final "PageFlip/Bitblit" output here....
    // We really don't need the function for this particular display (Unless we double buffered the text output)
    // Do all of the drawing in OnDraw..
    return S_OK;
  }

  // Step 36: Implement put_IsRealTime function from the ISynchronizeOutput interface 
  // When the user stops the display or continues back to streaming mode, this function will be called
  STDMETHODIMP put_IsRealTime( /*[in]*/ VARIANT_BOOL isRealTime )
  {
    if ( mIsRealTime == isRealTime ) return S_OK;

    // RealTime state changed here... For now, just set the member variable. 
    // "RealTime = VARIANT_TRUE means that the user is running the display continuously updating from the IADS clock
    // "RealTime = VARIANT_FALSE means that the user is paused or is in "scrollback" mode, updating from the analysis window's scrollbar position
    mIsRealTime = isRealTime;
    return S_OK;
  }

  // Helper function to demonstrate extracting data from a variant. For long/ulong/blob/ascii it might be best to create other function(s)
  double GetVariantValueHelper( VARIANT& v )
  {
    switch( v.vt )
    {
      case VT_R8:  return v.dblVal;
      case VT_R4:  return (double)v.fltVal;
      case VT_INT:
      case VT_I4:  return (double)v.lVal;
      case VT_UI4: return (double)v.ulVal;
      case VT_I2:  return (double)v.iVal;
      case VT_UI2: return (double)v.uiVal;
      case VT_I1:
      case VT_UI1: return (double)v.bVal;
      case VT_I8:  return (double)v.llVal;
      case VT_UI8: return (double)(__int64)v.ullVal; // This conversion could loose precision
    }

    VARIANT v2; 
    if ( ::VariantChangeType(&v2,&v,VARIANT_ALPHABOOL,VT_R8) != S_OK ) 
      return 0.0;
    return v2.dblVal;
  }

  // Example of processing blob data from a varint. This particular code verifies every data sample using a special
  // data set that produces blob with ramp data. See below for location on where to inject your own code
  void ProcessBlobDataFromVariant( VARIANT& v )
  {
    // If not blob data in this variant, return
    if ( v.vt != (VT_ARRAY|VT_UI1) )
      return; 

    // Get the SafeArray from the variant
    register SAFEARRAY* sa = v.parray;
    if ( !sa ) 
      return;

    // Extract the number of bytes in this blob/array. The size is the value of the unsigned int in the first 4 bytes
    unsigned __int32 numBytesInBlob = *((unsigned __int32*)sa->pvData);

    // Extract the data.. 4 bytes past the head of the blob
    BYTE* data = (BYTE*)sa->pvData + sizeof(unsigned __int32); 

    // At this point, the "payload" of the blob is in the data array 'data' (numBytesInBlob length)
    // Add your processing code here and remove mine below
    // memcpy( myArray, data, numBytesInBlob )
    // callMyProcessingFunction( myArray )
      
    // My processing code example for the blob. In my case, I have blob test data that contains
    // an incrementing ramp value within the blob data. If there's a discontinuity, output a debug message 
    int numIntsInBlob = numBytesInBlob / sizeof(unsigned __int32);
    unsigned __int32* dataArray = (unsigned __int32*)data;
    for( register int i=0; i<numIntsInBlob; i++ )
    {
      if ( mLastValue == 0 ) break;
      if ( dataArray[i] != (mLastValue+1) )
      {
        char m[500];
        sprintf( m, "Every data point error lastValue = %d  currentValue = %d\n", mLastValue, dataArray[i] );
        ::OutputDebugString( m );
        break;
      }
    }
    mLastValue = dataArray[0];
    mValueToDisplay = (double)mLastValue; // Create a new function if processing blobs exclusively
  }

};

OBJECT_ENTRY_AUTO(__uuidof(SampleEveryDataPoint2), CSampleEveryDataPoint2)
